/* Die folgenden Code-Beispiele stammen aus dem Buch:
 *  Objektorientiertes Programmieren in C++
 *   Ein Tutorial fr Ein- und Umsteiger
 * von Nicolai Josuttis, Addison-Wesley Mnchen, 2001
 *
 * (C) Copyright Nicolai Josuttis 2001.
 * Diese Software darf kopiert, verwendet, modifiziert und verteilt
 * werden, sofern diese Copyright-Angabe in allen Kopien vorhanden ist.
 * Diese Software wird "so wie sie ist" zur Verfgung gestellt.
 * Es gibt keine explizite oder implizite Garantie ber ihren Nutzen.
 */
/* Operator [] fr Variablen
 */
char& String::operator [] (unsigned i)
{
    // Index nicht im erlaubten Bereich ?
    if (i >= len) {
        /* Ausnahme:
         * - neu: String selbst und fehlerhaften Index bergeben
         */
        throw RangeError(*this,i);
    }

    return cstring[i];
}

/* Operator [] fr Konstanten
 */
const char String::operator [] (unsigned i) const
{
    // Index nicht im erlaubten Bereich ?
    if (i >= len) {
        /* Ausnahme:
         * - neu: String selbst und fehlerhaften Index bergeben
         */
        throw RangeError(*this,i);
    }

    return cstring[i];
}
